<?php 
/***************************************************************************
 *   
 *   countrycheck.php
 *
 *   copyright (C) 2006-2009 Click Here Software Co.
 *
 *   written by: Maurice Randall
 *
 *   distributed by: FixingTheWeb.com
 *
 *   email: support@fixingtheweb.com
 *
 *   Version 1.1 : December 8, 2009
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is used for blocking IP address ranges that are listed in
 *   files ht0.php through ht255.php. These are actually ranges of addresses
 *   for countries selected by using countryhtaccess.php.
 *
 *   This program is called by the .htaccess file using rewriting code.
 *
 *   Before using this program, you must run the setup utility countryiptsetup.php
 *   followed by selecting the countries to block with countryhtaccess.php.
 *   Also, be sure to read the documentation that was included with this package.
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This product can use either one of the following two country database
 *   files:
 *
 *   The IP-to-Country Database
 *   provided by WebHosting.Info (http://www.webhosting.info),
 *   available from http://ip-to-country.webhosting.info
 *
 *   or:
 *
 *   The GeoIP Database
 *   provided by MaxMind.com (http://www.maxmind.com),
 *   available from http://www.maxmind.com
 *
 ***************************************************************************/

/***************************************************************************
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *   
 ***************************************************************************/

// Edit this line to list where you have located this countrycheck.php file
// plus the notfound.php file and the badcountry.php file.
$country1_dir = "/country1/";

// Edit this line to list where you have located the htxxx.php files.
$country2_dir = "/country2/";

// Edit this to be what are most likely the index files on your website.
// This is used when a directory is accessed with or without a trailing slash.
// You can rearrange the order of these to speed up access. You can also
// add additional filenames.
$index_array = array(
  "index.php", "index.html", "index.htm"
);

/**************************************************************************

  NOTHING BEYOND THIS POINT NEEDS TO BE EDITED UNLESS YOU KNOW
  WHAT YOU ARE DOING AND LIKE TO EXPERIMENT.

**************************************************************************/

// This is used when the requested file is not found.
$notfoundfile = "notfound.php";

// This file is used when a request comes from a country that is being blocked.
$badcountryfile = "badcountry.php";

// Set up some variables to use.
$country1_base = $_SERVER['DOCUMENT_ROOT'].$country1_dir;
$country2_base = $_SERVER['DOCUMENT_ROOT'].$country2_dir;
$x_badcountryfile = $country1_base.$badcountryfile;
$x_notfoundfile = $country1_base.$notfoundfile;
$filereq = $_SERVER['DOCUMENT_ROOT'].$_SERVER['REDIRECT_URL'];
$path_info = parse_url($filereq);
$actualfile = $path_info['path'];

// If someone figures out the name of the country1 directory, this will
// prevent countrycheck.php from being loaded directly.
// Instead, the user will get badcountry.php just as if it was a country
// that we are blocking.
if ($_SERVER["REQUEST_URI"] == $country1_dir."countrycheck.php") {
  $_SERVER['REDIRECT_URL'] = $country1_dir.$badcountryfile;
}

// If this is a directory, we will find the index file.
// If no index file is found, the user will be presented
// with the notfoundfile. Directory listings are not possible.
$indexfound = 0;
if (is_dir($actualfile)) {
  foreach ($index_array as $defindex) {
    if (file_exists($actualfile."/".$defindex)) {
      $actualfile = $actualfile."/".$defindex;
      $indexfound = 1;
      break;
    }
  }
  if ($indexfound == 0) { $actualfile = $x_notfoundfile; }
}

// More variables to set up.
$x_path_parts=pathinfo($actualfile);
$x_extension="";
$x_dirname="";
$x_basename="";
if (isset($x_path_parts['extension'])) { $x_extension=$x_path_parts['extension']; }
if (isset($x_path_parts['dirname'])) { $x_dirname=$x_path_parts['dirname']; }
if (isset($x_path_parts['basename'])) { $x_basename=$x_path_parts['basename']; }

// Get info for the http header.
switch ($x_extension) {
   case 'php': $x_contentType='text/html'; $x_doecho=0; break;
   case 'php3': $x_contentType='text/html'; $x_doecho=0; break;
   case 'php4': $x_contentType='text/html'; $x_doecho=0; break;
   case 'html': $x_contentType='text/html'; $x_doecho=0; break;
   case 'htm': $x_contentType='text/html'; $x_doecho=0; break;
   case 'shtml': $x_contentType='text/html'; $x_doecho=0; break;
   case 'hdml': $x_contentType='text/x-hdml'; $x_doecho=0; break;
   case 'css': $x_contentType='text/css'; $x_doecho=1; break;
   case 'txt': $x_contentType='text/plain'; $x_doecho=1; break;

   case 'gif': $x_contentType='image/gif'; $x_doecho=1; break;
   case 'jpg': $x_contentType='image/jpeg'; $x_doecho=1; break;
   case 'jpeg': $x_contentType='image/jpeg'; $x_doecho=1; break;
   case 'png': $x_contentType='image/png'; $x_doecho=1; break;
   case 'ico': $x_contentType='image/x-icon'; $x_doecho=1; break;
   case 'bmp': $x_contentType='image/bmp'; $x_doecho=1; break;
   case 'tif': $x_contentType='image/tif'; $x_doecho=1; break;
   case 'tiff': $x_contentType='image/tiff'; $x_doecho=1; break;

   case 'mpg': $x_contentType='video/mpeg'; $x_doecho=1; break;
   case 'mpeg': $x_contentType='video/mpeg'; $x_doecho=1; break;
   case 'mov': $x_contentType='video/quicktime'; $x_doecho=1; break;
   case 'qt': $x_contentType='video/quicktime'; $x_doecho=1; break;
   case 'avi': $x_contentType='video/x-msvideo'; $x_doecho=1; break;

   case 'snd': $x_contentType='audio/basic'; $x_doecho=1; break;
   case 'mp3': $x_contentType='audio/mpeg'; $x_doecho=1; break;
   case 'mid': $x_contentType='audio/mid'; $x_doecho=1; break;
   case 'wav': $x_contentType='audio/x-wav'; $x_doecho=1; break;

   case 'zip': $x_contentType='application/zip'; $x_doecho=1; break;
   case 'tar': $x_contentType='application/x-tar'; $x_doecho=1; break;
   case 'wri': $x_contentType='application/x-mswrite'; $x_doecho=1; break;
   case 'dll': $x_contentType='application/x-msdownload'; $x_doecho=1; break;
   case 'gz': $x_contentType='application/x-gzip'; $x_doecho=1; break;
   case 'dvi': $x_contentType='application/x-dvi'; $x_doecho=1; break;
   case 'gtar': $x_contentType='application/x-gtar'; $x_doecho=1; break;
   case 'cpio': $x_contentType='application/x-cpio'; $x_doecho=1; break;
   case 'csh': $x_contentType='application/x-csh'; $x_doecho=1; break;
   case 'tgz': $x_contentType='application/x-compressed'; $x_doecho=1; break;
   case 'wcm': $x_contentType='application/vnd.ms-works'; $x_doecho=1; break;
   case 'wdb': $x_contentType='application/vnd.ms-works'; $x_doecho=1; break;
   case 'wks': $x_contentType='application/vnd.ms-works'; $x_doecho=1; break;
   case 'wps': $x_contentType='application/vnd.ms-works'; $x_doecho=1; break;
   case 'pot': $x_contentType='application/vnd.ms-powerpoint'; $x_doecho=1; break;
   case 'pps': $x_contentType='application/vnd.ms-powerpoint'; $x_doecho=1; break;
   case 'ppt': $x_contentType='application/vnd.ms-powerpoint'; $x_doecho=1; break;
   case 'xla': $x_contentType='application/vnd.ms-excel'; $x_doecho=1; break;
   case 'xlc': $x_contentType='application/vnd.ms-excel'; $x_doecho=1; break;
   case 'xlm': $x_contentType='application/vnd.ms-excel'; $x_doecho=1; break;
   case 'xls': $x_contentType='application/vnd.ms-excel'; $x_doecho=1; break;
   case 'xlt': $x_contentType='application/vnd.ms-excel'; $x_doecho=1; break;
   case 'xlw': $x_contentType='application/vnd.ms-excel'; $x_doecho=1; break;
   case 'rtf': $x_contentType='application/rtf'; $x_doecho=1; break;
   case 'ps': $x_contentType='application/postscript'; $x_doecho=1; break;
   case 'eps': $x_contentType='application/postscript'; $x_doecho=1; break;
   case 'bin': $x_contentType='application/octet-stream'; $x_doecho=1; break;
   case 'exe': $x_contentType='application/octet-stream'; $x_doecho=1; break;
   case 'lha': $x_contentType='application/octet-stream'; $x_doecho=1; break;
   case 'lzh': $x_contentType='application/octet-stream'; $x_doecho=1; break;
   case 'doc': $x_contentType='application/msword'; $x_doecho=1; break;
   case 'pdf': $x_contentType='application/pdf'; $x_doecho=1; break;
   default: $x_contentType='unknown'; $x_doecho=1; break;
}

// Add the header and send it to apache.
if ($x_contentType <> 'unknown' ) {
   Header('Content-type: '.$x_contentType.'; name='.$x_basename);
}

// Check now if a blocked country is attempting access.
// We will only send the badcountryfile if the original
// request was for a php file. Otherwise, we just send them nothing at all.
if ((x_checkBadCountry($_SERVER['REMOTE_ADDR']) | ($x_basename == "countryblocktester.php"))) {
  if ($x_extension == "php") {
    if (file_exists($x_badcountryfile)) {
      include($x_badcountryfile);
    }
  }
exit;
}

// Now let's send the data from the requested file to apache.
if (file_exists($actualfile)) {
  if ($x_doecho ==1 ) {
    $handle = fopen($actualfile, "r");
    echo (fread($handle, filesize($actualfile)));
    fclose($handle);
  }
  else {
    chdir($x_dirname);
    include($actualfile);
  }
}
elseif (file_exists($x_notfoundfile)) {
   include($x_notfoundfile);
}
else {
   echo 'Requested file not found...';
}

// This does the work of looking up the IP address to see if we should
// allow it or not.

function x_checkBadCountry($rem_ipaddr) {
$junk = 0;
global $country2_base;
list ($decipaddress, $dot0) = x_dot2dec($rem_ipaddr);

if (file_exists($country2_base."ht".$dot0.".php")) {
   include($country2_base."ht".$dot0.".php");
}
// If the database files are not found, we will exit and allow everyone.
// This allows the database to be built or rebuilt while the .htaccess
// files are still in use.
else {
   return $junk;
}

if ($htranges=="") { return $junk; }
foreach($htranges as $key => $value) {
   if($decipaddress<=$htranges[$key][0]){
      if($decipaddress>=$key){
         $junk=1;
      }
      break;
   }
}

return $junk;
}

function x_dot2dec($dotip) {
    $numbers = preg_split( "/\./", $dotip);
    $decip = ($numbers[0]*16777216)+($numbers[1]*65536)+($numbers[2]*256)+($numbers[3]);
    return array ($decip, $numbers[0]);
}

?>

