<?php
/***************************************************************************
 *   
 *   countryhtaccess.php
 *
 *   copyright (C) 2006-2009 Click Here Software Co.
 *
 *   written by: Maurice Randall
 *
 *   distributed by: FixingTheWeb.com
 *
 *   email: support@fixingtheweb.com
 *
 *   Version 1.1 : December 7, 2009
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is used for selecting the countries you wish to block from
 *   having access to your web site. It will then create a series of files
 *   that are used by countrycheck.php from an .htaccess file.
 *
 *   Before using this program, you must run the setup utility countryipsetup.php.
 *   Also, be sure to read the documentation that was included with this package.
 *
 ***************************************************************************/

/***************************************************************************
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *   
 ***************************************************************************/

// The version number of this release.
$COUNTRY_VERSION="V1.1";

// The name of the file containing the country list.
$COUNTRY_LIST="countries.php";

// Amount of time (in seconds) given to the server to create the file.
$DEF_TIME_LIMIT=600;

if (file_exists($COUNTRY_LIST)) {
   include($COUNTRY_LIST);
   asort($countries);
}
else {
   errorExit("Database file not found: ($COUNTRY_LIST)");
}

?>
<html>
<head>
<title>
HTAccess Country Blocker
</title>
</head>
<body>

<font size="+1"><b>Generate Country Blocking Files for countrycheck.php</b></font>
<?php echo "<br>countryhtaccess.php ".$COUNTRY_VERSION; ?>
<p><font size="-1"><b>Visit fixingtheweb.com for this and other useful stuff.</b></font>
<p>
<form method="POST" action="menu.php">
<input type=submit  value="Main Menu" name="mainmenu">
</form>
<hr>

<form method="POST" action="countryhtaccess.php"> 

<font size=+1><b>Select the countries you wish to block:</b></font>
<br>and then click: <input type=submit  value="Begin" name="Begin">

<p>
<br><input type=submit value="Load Default Selections" name="LoadDefaults">
&nbsp;<input type=submit value="Save As Defaults" name="SaveDefaults">
&nbsp;<input type=submit value="Select All" name="SelectAll">
&nbsp;<input type=submit value="Clear All" name="ClearAll">

<?php


$bad_countries = array();


if (isset($_POST['SaveDefaults']) || isset($_POST['Begin'])) {
   $cs = $_POST['cs'];
   $n = count($cs);
   foreach($countries as $key => $value) {
      $countries[$key][0]="OK";
      $i = 0;
      while ($i < $n) {
         if ($key==$cs[$i]) {
            $countries[$key][0]="BAD";
            $bad_countries[] = $key;
            break;
         }
         $i++;
      }
   }
}

if (isset($_POST['SaveDefaults'])) {
   if (is_writeable("./")==FALSE) {
      errorExit("Unable to write in this directory");
   }
   if (is_writeable($COUNTRY_LIST)) {
      if (($handle = fopen($COUNTRY_LIST, "w"))==FALSE) {
         errorExit("Unable to update file: $COUNTRY_LIST");
      }
   }
   else {
      errorExit("Unable to update file: $COUNTRY_LIST");
   }
   writeFileLine($handle, "<?php \n");
   writeFileLine($handle, "\$countries=array(\n");
   foreach($countries as $key => $value) {
      if ($countries[$key][0]<>"BAD") { $countries[$key][0]="OK"; }
      $key0=$countries[$key][0];
      $key1=$countries[$key][1];
      $fileLine="\"$key\" => array(\"$key0\",\"$key1\"),\n";
      writeFileLine($handle, $fileLine);
   }
   writeFileLine($handle, ");\n?>");
   fclose($handle);
}



if (isset($_POST['ClearAll'])) {
    foreach($countries as $key => $value)
    {
       $countries[$key][0]="OK";
    }
}

if (isset($_POST['SelectAll'])) {
    foreach($countries as $key => $value)
    {
       $countries[$key][0]="BAD";
    }
}


if (isset($_POST['Begin']))  {

set_time_limit($DEF_TIME_LIMIT);

$rangeCount=0;

do {

if (file_exists($rangeCount.".php")) {
   include($rangeCount.".php");
}
else {
   errorExit("Database file not found: $rangeCount".".php");
}

// Open the new or existing file for writing/rewriting.
$htfilename="ht".$rangeCount.".php";
if (file_exists($htfilename)) {
   if (is_writeable($htfilename) ==FALSE) {
      errorExit("Unable to write to file: $htfilename");
   }
}
if ((is_writeable("./"))==FALSE) {
   errorExit("Unable to write in this directory");
}
else {
   if (($handle = fopen($htfilename, "w")) ==FALSE) {
      errorExit("Unable to create file: $htfilename");
   }
}


// Add content to the file.

$oldRange="";
$startFound=0;

$htline="<?php \n\$htranges = array(\n";
writeFileLine($handle, $htline);

foreach($ranges as $key => $value)
{
    if (ckifbadcountry($ranges[$key][1])=="BAD") {
       $rangehigh=$ranges[$key][0];
       if ($startFound==0) {
          $rangelow=$key;
          $startFound=1;
       }
    }
    else {
       if ($startFound) {
          $startFound=0;
          $range="$rangelow-$rangehigh";
          if ("$range"<>"$oldRange") {
             $oldRange="$range";
      $htline="\"$rangelow\" => array(\"$rangehigh\"),\n";
             writeFileLine($handle, $htline);
          }
       }
    }
}

if ($startFound) {
   $startFound=0;
   $range="$rangelow-$rangehigh";
   if ("$range"<>"$oldRange") {
      $oldRange="$range";
      $htline="\"$rangelow\" => array(\"$rangehigh\"),\n";
      writeFileLine($handle, $htline);
    }
}

$htline=");\n?>";
writeFileLine($handle, $htline);
fclose($handle);
chmod($htfilename, 0777);

$rangeCount+=1;

} while ($rangeCount<256);


}

// Create the display of countries and checkboxes.

print "<table width=\"96%\" align=\"center\">\n";

$cellCount=0;

foreach($countries as $key => $value)
{
    if ($cellCount==0) { print "<tr>\n"; }
    print "<td width=\"33%\">\n";
    $checked="";
    $curCountry=$countries[$key][1];
    if ($countries[$key][0]=="BAD") { $checked=" checked"; }
    print "<input type=\"checkbox\" name=\"cs[]\" value=\"$key\" $checked>";
    print "$curCountry\n";
    print "</td>\n";
    $cellCount+=1;
    if ($cellCount==3) { print "</tr>\n"; $cellCount=0; }
}

if ($cellCount<>3) {
    while ($cellCount) {
       print "<td width=\"33%\">&nbsp;</td>\n";
       $cellCount-=1;
    }
    print "</tr>\n";
}

print "</table>\n";
print "</form>\n";


function writeFileLine($handle, $fileline) {
   if (fwrite($handle, $fileline) == FALSE) {
       errorExit("Cannot write to file: $handle");
   }
}

function ckifbadcountry($ckcountry) {
    global $bad_countries;
    $countryck="OK";
    foreach($bad_countries as $value) {
       if ($ckcountry==$value) { $countryck="BAD"; break; }
    }
    return $countryck;
}


function dectodot($decip) {
    $num0 = floor($decip/16777216);
    $tmp1 = $num0*16777216;
    $num1 = floor(($decip-$tmp1)/65536);
    $tmp2 = $num1*65536;
    $num2 = floor(($decip-$tmp1-$tmp2)/256);
    $tmp3 = $num2*256;
    $num3 = $decip-$tmp1-$tmp2-$tmp3;
    return $num0.".".$num1.".".$num2.".".$num3;
}

function errorExit($errorMsg) {
   print "</table>\n";
   print "</form>\n";
   print "<br><p><b>Error:</b> $errorMsg\n";
   print "\n</body>\n</html>\n";
   exit;
}

?>

</body>
</html>
