<?php 
/***************************************************************************
 *   
 *   countryhtsetup.php
 *
 *   copyright (C) 2006-2009 Click Here Software Co.
 *
 *   written by: Maurice Randall
 *
 *   distributed by: FixingTheWeb.com
 *
 *   email: support@fixingtheweb.com
 *
 *   Version 1.5 : December 7, 2009
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This is the setup utility used for creating the IP address and country
 *   database files. The files will be created in the same directory where
 *   this file resides. Be sure to read the documentation that was included
 *   with this package. This utility also requires that the
 *   GeoIPCountryWhois.csv or ip-to-country.csv file be located in this same
 *   directory.
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This product can use either one of the following two country database
 *   files:
 *
 *   The IP-to-Country Database
 *   provided by WebHosting.Info (http://www.webhosting.info),
 *   available from http://ip-to-country.webhosting.info
 *
 *   or:
 *
 *   The GeoIP Database
 *   provided by MaxMind.com (http://www.maxmind.com),
 *   available from http://www.maxmind.com
 *
 ***************************************************************************/

/***************************************************************************
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *   
 ***************************************************************************/

// The version number of this release.
$COUNTRYSETUP_VERSION="V1.4";

// The name of the file containing the country list.
$COUNTRY_LIST="countries.php";

// Amount of time (in seconds) given to the server to create the database files.
$DEF_TIME_LIMIT=600;

// Name of file downloaded from http://www.maxmind.com
$GEOIP_FILENAME="GeoIPCountryWhois.csv";
// Name of file downloaded from http://ip-to-country.webhosting.info
$IPTOCOUNTRY_FILENAME="ip-to-country.csv";

?>
<html>
<head>
<title>
IPTables Country Blocker Setup
</title>
</head>
<body>

<font size="+1"><b>Generate Database Files for the HTCountryBlock package</b></font>
<?php echo "<br>countryhtsetup.php ".$COUNTRYSETUP_VERSION; ?>
<p><font size="-1"><b>Visit fixingtheweb.com for this and other useful stuff.</b></font>
<p>
<form method="POST" action="menu.php">
<input type=submit  value="Main Menu" name="mainmenu">
</form>
<hr>
<table width="80%" align="center">
<tr>
<td>
<p>
This is the setup program that will build the database files from the country database (.csv) file. This only needs to be done the first time you are setting up and again whenever you update to a newer country database (.csv) file. Also, whenever you update the .csv file and rebuild your database files, you must also run countryhtaccess.php afterwards to rebuild your htxxx.php files.
<p>
If you haven't yet downloaded the .csv file, go to ip-to-country.webhosting.info or to www.maxmind.com to download whichever .csv file you wish to use.
<p>
Make sure the permissions are set correctly for the directory you are running this from so your web server can create the new files needed by &quot;countryhtaccess.php&quot; and &quot;iptocountry.php&quot;.
<p>
Also, make sure the .csv file is located in this same directory.
<p>
When ready, click on &quot;Generate Database&quot; to create the files.
<p>
<form method="POST" action="countryhtsetup.php"> 
<input type=submit  value="Generate Database" name="GenerateDatabase">
</form>

</td>
</tr>
</table>

<?php 

if (isset($_POST['GenerateDatabase'])) {

  set_time_limit($DEF_TIME_LIMIT);

  // Set some defaults that will be overridden if they exist in countries.php
  $ethDefault="eth0";
  $ethmethodDefault=0;

  // If countries.php exists, we will preserve the current settings.
  if (file_exists($COUNTRY_LIST)) {
     include ($COUNTRY_LIST);
     $bad_countries = array();
     foreach($countries as $key => $value) {
        if ($countries[$key][0]=="BAD") { $bad_countries[] = $key; }
     }
  }

  $countries = array();

  $csvName=0;
  if (file_exists($IPTOCOUNTRY_FILENAME)) {
     $csvhandle = fopen($IPTOCOUNTRY_FILENAME, "r");
  }
  else {
     if (file_exists($GEOIP_FILENAME)) {
        $csvhandle = fopen($GEOIP_FILENAME, "r");
        $csvName=1;
     }
     else {
        errorExit("File not found: $IPTOCOUNTRY_FILENAME or $GEOIP_FILENAME");
     }
  }

  // Check if we can write in this directory.
  if ((is_writeable("./"))==FALSE) {
     errorExit("Unable to write in this directory");
  }


  $frange=0;

  // First see if the file exists and can be written to.
  if (file_exists($frange.".php")) {
     if (is_writeable($frange.".php")==FALSE) {
        errorExit("Unable to update file: $frange".".php");
     }
  }
  // Now either open it for writing (if exists) or create a new file.
  if (($rangehandle = fopen($frange.".php", "w")) ==FALSE) {
        errorExit("Unable to create file: $frange".".php");
  }

  list ($startIP, $endIP, $cn2, $cn) = getnxtline($csvhandle);
  $startDot=dectodot($startIP);
  $endDot=dectodot($endIP);
  list ($startMSB) = preg_split( "/\./", $startDot);
  list ($endMSB) = preg_split( "/\./", $endDot);
  $countryFound=0;
  foreach($countries as $key => $value) {
     if ($key==$cn2) {
        $countryFound=1;
        break;
     }
  }
  if ($countryFound==0) {
     $countries[$cn2] = $cn;
  }

  do {
     $fileline="<?php \n\$ranges = array(\n";
     writefline($rangehandle, $fileline);

     do {
        $needNxtLine=0;
        if ($frange==$startMSB && $frange==$endMSB) {
           $fileline="\"$startIP\" => array(\"$endIP\",\"$cn2\"),\n";
           writefline($rangehandle, $fileline);
           $needNxtLine=1;
        }
        elseif ($frange==$startMSB && $frange<$endMSB) {
           $tmp2IP=(($frange * 16777216) + 16777215);
           $fileline="\"$startIP\" => array(\"$tmp2IP\",\"$cn2\"),\n";
           writefline($rangehandle, $fileline);
        }
        elseif ($frange>$startMSB && $frange<$endMSB) {
           $tmp1IP=($frange * 16777216);
           $tmp2IP=(($frange * 16777216) + 16777215);
           $fileline="\"$tmp1IP\" => array(\"$tmp2IP\",\"$cn2\"),\n";
           writefline($rangehandle, $fileline);
        }
        elseif ($frange>$startMSB && $frange==$endMSB) {
           $tmp1IP=($frange * 16777216);
           $fileline="\"$tmp1IP\" => array(\"$endIP\",\"$cn2\"),\n";
           writefline($rangehandle, $fileline);
           $needNxtLine=1;
        }

        if ($needNxtLine) {
           list ($startIP, $endIP, $cn2, $cn) = getnxtline($csvhandle);
           if ($startIP=="") { break; }
           $startDot=dectodot($startIP);
           $endDot=dectodot($endIP);
           list ($startMSB) = preg_split( "/\./", $startDot);
           list ($endMSB) = preg_split( "/\./", $endDot);
           $countryFound=0;
           foreach($countries as $key => $value) {
              if ($key==$cn2) {
                 $countryFound=1;
                 break;
              }
           }
           if ($countryFound==0) {
              $countries[$cn2] = $cn;
           }
        }

     } while ($needNxtLine);

     $fileline=");\n?> \n";
     writefline($rangehandle, $fileline);

     fclose($rangehandle);
     chmod($frange.".php", 0777);
     $frange+=1;
     if ($frange<256) {
          if (($rangehandle = fopen($frange.".php", "w")) ==FALSE) {
           errorExit("Unable to create/write to file: $frange".".php");
        }
     }
  } while ($frange<256);


  fclose($csvhandle);

  // Now build the countries.php file

  if (file_exists($COUNTRY_LIST)) {
     if ((is_writeable($COUNTRY_LIST)) ==FALSE) {
        errorExit("Unable to update file: $COUNTRY_LIST");
     }
  }
  if (($countryhandle = fopen($COUNTRY_LIST, "w"))==FALSE) {
     errorExit("Unable to update/create file: $COUNTRY_LIST");
  }

  writefline($countryhandle, "<?php \n");
  writefline($countryhandle, "\$ethDefault=\"".$ethDefault."\";\n");
  writefline($countryhandle, "\$ethmethodDefault=".$ethmethodDefault.";\n");
  writefline($countryhandle, "\$countries=array(\n");
  foreach($countries as $key => $value) {
     $countryCheck=ckifbadcountry($key);
     $fileline="\"$key\" => array(\"$countryCheck\",\"$value\"),\n";
     writefline($countryhandle, $fileline);
  }
  $fileline=");\n?> \n";
  writefline($countryhandle, $fileline);
  fclose($countryhandle);
  chmod($COUNTRY_LIST, 0777);

}


function writefline($handle, $fileline) {
   if (fwrite($handle, $fileline) === FALSE) {
       echo "Cannot write to file";
       exit;
   }
}

function dectodot($decip) {
    $num0 = floor($decip/16777216);
    $tmp1 = $num0*16777216;
    $num1 = floor(($decip-$tmp1)/65536);
    $tmp2 = $num1*65536;
    $num2 = floor(($decip-$tmp1-$tmp2)/256);
    $tmp3 = $num2*256;
    $num3 = $decip-$tmp1-$tmp2-$tmp3;
    return $num0.".".$num1.".".$num2.".".$num3;
}

function getnxtline($csvhandle) {
   global $csvName;
   $csvline = fgets($csvhandle, 200);
   $csvline = trim($csvline, "\x22.\x0D.\x0A");
   if ($csvName) {
      list ($toss0, $toss1, $startIP, $endIP, $cn2, $cn) = preg_split( '/\"\,\"/', $csvline);
   }
   else {
      list ($startIP, $endIP, $cn2, $cn3, $cn) = preg_split( '/\"\,\"/', $csvline);
   }
   return array ($startIP, $endIP, $cn2, $cn);
}

function ckifbadcountry($ckcountry) {
   $countryck="OK";
   global $bad_countries;
   if (($bad_countries)<>"") {
      foreach($bad_countries as $value) {
         if ($ckcountry==$value) { $countryck="BAD"; break; }
      }
   }
   return $countryck;
}

function errorExit($errorMsg) {
   print "<br><p><b>Error:</b> $errorMsg\n";
   print "\n</body>\n</html>\n";
   exit;
}

?>

</body>
</html>
