<?php 
/***************************************************************************
 *   
 *   iptocountry.php
 *
 *   copyright (C) 2006 Click Here Software Co.
 *
 *   written by: Maurice Randall
 *
 *   distributed by: FixingTheWeb.com
 *
 *   email: support@fixingtheweb.com
 *
 *   Version 1.3 : November 22, 2006
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is used for displaying the country an IP address belongs
 *   to. It will also display 6 countries that are immediately before it
 *   as well as 6 countries that immediately follow it.
 *
 *   Before using this program, you must run the setup utility countryipsetup.php.
 *   Also, be sure to read the documentation that was included with this package.
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This product can use either one of the following two country database
 *   files:
 *
 *   The IP-to-Country Database
 *   provided by WebHosting.Info (http://www.webhosting.info),
 *   available from http://ip-to-country.webhosting.info
 *
 *   or:
 *
 *   The GeoIP Database
 *   provided by MaxMind.com (http://www.maxmind.com),
 *   available from http://www.maxmind.com
 *
 ***************************************************************************/

/***************************************************************************
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *   
 ***************************************************************************/

// The version number of this release.
$IPTOCOUNTRY_VERSION="V1.3";

// The name of the file containing the country list.
// This is built from the .csv database file
// by the setup program countryiptsetup.php
$COUNTRY_LIST="countries.php";

if (isset($_GET["ipaddress"])) { $ipaddress=$_GET["ipaddress"]; }
  else { $ipaddress=""; }

?>
<html>
<head>
<title>
Country IP Address Identification
</title>
</head>
<body>

<font size="+1"><b>IP ADDRESS TO COUNTRY</b></font>
<?php echo "<br>iptocountry.php ".$IPTOCOUNTRY_VERSION; ?>
<p><font size="-1"><b>Visit fixingtheweb.com for this and other useful stuff.</b></font>
<p>
<form method="POST" action="menu.php">
<input type=submit  value="Main Menu" name="mainmenu">
</form>
<hr>
<table align="center" width="100%">
<tr>
<td width="50%">

<form method="GET" action="iptocountry.php"> 
Input IP Address<BR>
<input type=text name=ipaddress size=15

<?php
print "value=$ipaddress".">";
?>
&nbsp;<input type=submit  value="Get IP Info">
<?php
if ($ipaddress<>"") {
print "&nbsp;<a href=\"iptocountry.php\">Help</a>";
}
?>
</form>

<?php

if ($ipaddress=="") {

print "</td>\n";
print "<td width=\"50%\">\n";
print "&nbsp;\n";
print "</td>\n";
print "</tr>\n";
print "</table>";
print "<hr>\n";

print "<table width=\"80%\" align=\"center\">";
print "<tr>\n";
print "<td>\n";

print "
Enter an IP address in either the standard dot decimal format or in the long decimal format. 
For instance, entering either 123.123.123.123 or 2071690107 will return the same results.
<p>The results returned will show both forms of the IP address entered along with the range
of addresses this IP address falls into and the country for that range.
<p>
There will also be two columns of results displayed that will show the ranges of IP addresses
that fall just before this IP address range and those that fall just after this IP address range.
<p>
If the IP address entered is not listed in the database, the country will display as
&quot;unknown&quot; but the range of addresses for this unknown region will also be displayed.
<p>
You can also enter a partial dot IP address with 2 or 3 segments such as &quot;218.0&quot; or &quot;218.0.3&quot;.
";

print "</td>\n";
print "</tr>\n";
print "</table>";

}
else {

if (file_exists($COUNTRY_LIST)) {
   include($COUNTRY_LIST);
}
else {
   errorExit("Database file not found: ($COUNTRY_LIST)");
}

list ($decipaddress, $dot0, $dot1, $dot2, $dot3) = dottodec($ipaddress);


$ipBAD=0;

if ($dot1<>"") {
   $dotlist = array ($dot0, $dot1, $dot2, $dot3);
   foreach($dotlist as $dot) {
       if ($dot=="") { $dot="0"; }
       if (strlen($dot)>3) { $ipBAD += 1; break; }
       if (ctype_digit($dot)<>TRUE) { $ipBAD += 1; break; }
       if ($dot>255) { $ipBAD += 1; break; }
   }
   list ($dot0, $dot1, $dot2, $dot3) = dectodot($decipaddress);
}
else
{
   if (ctype_digit($ipaddress)<>TRUE) { $ipBAD += 1;}
   $ipaddress=floor($ipaddress);
   list ($dot0, $dot1, $dot2, $dot3) = dectodot($ipaddress);
   $decipaddress = $ipaddress;
}

if ($decipaddress >= 4294967296) { $ipBAD += 1; }

if ($ipBAD) {
   print "IP address entered wrong - Please correct and submit again\n";
   exit;
}

print "Decimal address = $decipaddress"."\n<br>\n";
print "IP Address requested = ";
print $dot0.'.'.$dot1.'.'.$dot2.'.'.$dot3."\n<p>\n";

print "</td>\n";
print "<td width=\"50%\">\n";

print "<p><b>Info for IP range request:</b>"."\n<p>\n";

list ($startip, $endip) = dorangeinfo($dot0, $decipaddress);

print "</td>\n";
print "</tr>\n";

print "<tr>\n";
print "<td colspan=2>\n";
print "<hr>\n";
print "</td>\n";
print "</tr>\n";

print "<tr>\n";
print "<td width=\"50%\">\n";

print "<p><b>Country ranges just ahead of this one:</b>"."\n<p>\n";

print "</td>\n";
print "<td width=\"50%\">\n";

print "<p><b>Country ranges just beyond this one:</b>"."\n<p>\n";

print "</td>\n";
print "</tr>\n";
print "<tr>\n";
print "<td valign=\"top\" width=\"50%\">\n";

$i=0;
do {

  list ($dotZ0, $dotZ1, $dotZ2, $dotZ3) = dectodot($startip-1);
  if ($dotZ0 < 0) { break; }
  list ($startipZ, $endipZ) = dorangeinfo($dotZ0, $startip-1);

  list ($dotY0, $dotY1, $dotY2, $dotY3) = dectodot($startipZ-1);
  if ($dotY0 < 0) { break; }
  list ($startipY, $endipY) = dorangeinfo($dotY0, $startipZ-1);

  list ($dotX0, $dotX1, $dotX2, $dotX3) = dectodot($startipY-1);
  if ($dotX0 < 0) { break; }
  list ($startipX, $endipX) = dorangeinfo($dotX0, $startipY-1);

  list ($dotW0, $dotW1, $dotW2, $dotW3) = dectodot($startipX-1);
  if ($dotW0 < 0) { break; }
  list ($startipW, $endipW) = dorangeinfo($dotW0, $startipX-1);

  list ($dotV0, $dotV1, $dotV2, $dotV3) = dectodot($startipW-1);
  if ($dotV0 < 0) { break; }
  list ($startipV, $endipV) = dorangeinfo($dotV0, $startipW-1);

  list ($dotU0, $dotU1, $dotU2, $dotU3) = dectodot($startipV-1);
  if ($dotU0 < 0) { break; }
  list ($startipU, $endipU) = dorangeinfo($dotU0, $startipV-1);

} while ($i>0);

print "</td>\n";
print "<td valign=\"top\" width=\"50%\">\n";

$i=0;
do {
  list ($dotA0, $dotA1, $dotA2, $dotA3) = dectodot($endip+1);
  if ($dotA0 > 255) { break; }
  list ($startipA, $endipA) = dorangeinfo($dotA0, $endip+1);

  list ($dotB0, $dotB1, $dotB2, $dotB3) = dectodot($endipA+1);
  if ($dotB0 > 255) { break; }
  list ($startipB, $endipB) = dorangeinfo($dotB0, $endipA+1);

  list ($dotC0, $dotC1, $dotC2, $dotC3) = dectodot($endipB+1);
  if ($dotC0 > 255) { break; }
  list ($startipC, $endipC) = dorangeinfo($dotC0, $endipB+1);

  list ($dotD0, $dotD1, $dotD2, $dotD3) = dectodot($endipC+1);
  if ($dotD0 > 255) { break; }
  list ($startipD, $endipD) = dorangeinfo($dotD0, $endipC+1);

  list ($dotE0, $dotE1, $dotE2, $dotE3) = dectodot($endipD+1);
  if ($dotE0 > 255) { break; }
  list ($startipE, $endipE) = dorangeinfo($dotE0, $endipD+1);

  list ($dotF0, $dotF1, $dotF2, $dotF3) = dectodot($endipE+1);
  if ($dotF0 > 255) { break; }
  list ($startipF, $endipF) = dorangeinfo($dotF0, $endipE+1);

} while ($i>0);

print "</td>\n";
print "</tr>\n";
print "</table>\n";

}

function dorangeinfo($msb, $decip) {
   global $adj;
   list ($country2L, $decrangestart, $decrangeend) = iptocountry($msb, $decip);
   if ($country2L=="XXX") {
         list ($country2L, $decrangestart, $decrangeend) = iptocountry($msb, $decip);
   }
   if ($country2L=="XX") {
      $country="unknown";
   }
   else {
      $country = lookupcountry($country2L);
   }
   print "Country = $country"."\n<br>\n";
   print "Decimal IP Range = $decrangestart - $decrangeend"."\n<br>\n";
   print "Dot IP Range = ";
   list ($beg0, $beg1, $beg2, $beg3) = dectodot($decrangestart);
   print $beg0.'.'.$beg1.'.'.$beg2.'.'.$beg3.' - ';
   list ($end0, $end1, $end2, $end3) = dectodot($decrangeend);
   print $end0.'.'.$end1.'.'.$end2.'.'.$end3."\n<p>\n";
   return array ($decrangestart, $decrangeend);
}

function iptocountry($dot0ip, $decip) {
    $country="XX";
    $rangelow=$dot0ip*16777216;
    $rangehigh=$rangelow+16777215;

    if (file_exists($dot0ip.".php")) {
       include($dot0ip.".php");
    }
    else {
       errorExit("Database file not found: ($dot0ip".".php".")");
    }
    if ($ranges=="") { return array ("XXX", $rangelow, $rangehigh); }
    foreach($ranges as $key => $value)
    {
        if($key<=$decip){
            if($ranges[$key][0]>=$decip){
               $rangelow=$key;
               $rangehigh=$ranges[$key][0];
               $country=$ranges[$key][1];
               break;
            }
        }
    }
    if ($country == "XX") {
       $country = "XXX";
       foreach($ranges as $key => $value)
       {
           if($key>=$decip){
               $rangehigh=$key-1;
               $country == "XX";
               break;
           }
           $rangelow=$ranges[$key][0]+1;
       }
    }
    return array ($country, $rangelow, $rangehigh);
}


function lookupcountry($c2L) {
    global $countries;
    $country = "unknown";
    foreach($countries as $key => $value)
    {
        if($key==$c2L){
            $country = $countries[$key][1];
            break;
	}
    }
    return($country);
}

function dottodec($dotip) {
    if (!isset($numbers[2])) { $numbers[2]=0; }
    $numbers = preg_split( "/\./", $dotip);
    if (!isset($numbers[1])) { $numbers[1]=0; }
    if (!isset($numbers[2])) { $numbers[2]=0; }
    if (!isset($numbers[3])) { $numbers[3]=0; }
    $decip = ($numbers[0]*16777216)+($numbers[1]*65536)+($numbers[2]*256)+($numbers[3]);
    return array ($decip, $numbers[0], $numbers[1], $numbers[2], $numbers[3]);
}

function dectodot($decip) {
    $num0 = floor($decip/16777216);
    $tmp1 = $num0*16777216;
    $num1 = floor(($decip-$tmp1)/65536);
    $tmp2 = $num1*65536;
    $num2 = floor(($decip-$tmp1-$tmp2)/256);
    $tmp3 = $num2*256;
    $num3 = $decip-$tmp1-$tmp2-$tmp3;
    return array ($num0, $num1, $num2, $num3);
}

function errorExit($errorMsg) {
   print "\n</td>\n</tr>\n</table>\n";
   print "<br><p><b>Error:</b> $errorMsg\n";
   print "\n</body>\n</html>\n";
   exit;
}

?>

</body>
</html>
